#include <Random.h>
#include <iostream>
#include <vector>
using namespace std;

int main()
{
  constexpr int minimum{10};
  constexpr int maximum{20};
  static_assert(maximum > minimum, "maximum muss > minimum sein!");
  constexpr int iterationen{100000};
  vector<int> haeufigkeit(maximum - minimum + 1, 0);
  Random zufall(minimum, maximum);
  random_device rd;
  // zufall.setSeed(rd()); // ohne '//': keine Reproduzierbarkeit
  // Zufallszahl erzeugen, dabei die Häufigkeit hochzählen:
  for (int i = 0; i < iterationen; ++i) {
    ++haeufigkeit[zufall() - minimum];
  }
  // Häufigkeiten und Mittelwert ausgeben
  double summe = 0.0;
  for (int i{0}; i < ssize(haeufigkeit); ++i) {
    int wert = i + minimum;
    cout << wert << ": " << haeufigkeit[i] << '\n';
    summe += wert * haeufigkeit[i];
  }
  cout << "Mittelwert: " << summe / iterationen << '\n';
}

