#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
using namespace std;

int main()
{
  constexpr double minimum{-3.0};            // darzustellender Bereich
  constexpr double maximum{3.0};
  constexpr int intervalle{80};              // Auflösung der Ausgabe (Spalten)
  constexpr int zeilen = 20;                 // Auflösung der Ausgabe (Zeilen)
  constexpr double intervallbreite{(maximum - minimum) / intervalle};
  constexpr int iterationen = 1000000;

  vector<int> haeufigkeit(intervalle, 0);
  normal_distribution<> gauss(0.0, 1.0);     // Mittelwert, Standardabweichung
  mt19937 generator;
  random_device rd;
  generator.seed(rd());                      // jedes Mal neue Werte
  // Zufallszahl erzeugen, dabei die Häufigkeit hochzählen
  for (int i = 0; i < iterationen; ++i) {
    double wert = gauss(generator);
    if (wert > minimum && wert < maximum) {
      ++haeufigkeit[(wert - minimum) / intervallbreite];
    }                                        // else.. Außenbereiche ignorieren
  }
  // Grobe Darstellung der Glockenkurve auf der Konsole
  int max = *max_element(haeufigkeit.begin(), haeufigkeit.end());
  for (int i = 0; i < zeilen; ++i) {
    for (int j = 1; j < intervalle; ++j) {
      double grenze = static_cast<double>(haeufigkeit[j]) * zeilen / max + 0.5;
      cout << (grenze <= (zeilen - i) ? ' ' : '*');
    }
    cout << '\n';
  }
}
