#include <iostream>
#include <tuple>
#include <utility>

template <typename Tuple, size_t I, size_t... Zahlenfolge>
auto berechnesumme(const Tuple& t, std::integer_sequence<std::size_t, I, Zahlenfolge...> z)
{
  auto ergebnis = std::get<I>(t);
  if constexpr(z.size() > 1) {
    ergebnis += berechnesumme(t, std::integer_sequence<std::size_t, Zahlenfolge...>());
  }
  return ergebnis;
}

template <typename... T> auto tupelsumme(const std::tuple<T...>& t)
{
  using indexfolge = std::make_integer_sequence<std::size_t, sizeof...(T)>;
  return berechnesumme(t, indexfolge());
}

int main()
{
  auto tupel{std::make_tuple(3.1, 4.2, -17.0)};
  std::cout << tupelsumme(tupel) << '\n';
}
