#include <iostream>
#include <string>
#include <tuple>

template <typename T>
void anzeigen(const T& was)                  // anzuwendende Funktion
{ 
  std::cout << was << '\n'; 
}

template <int I, class Tupel>
constexpr void zeigeElemente(const Tupel& tupel)
{
  if constexpr (I > 0) {
    zeigeElemente<I - 1, Tupel>(tupel);
    anzeigen(std::get<I - 1>(tupel));
  }
}

int main()
{
  auto tupel = std::make_tuple("Donald", "Duck", 17);
  zeigeElemente<std::tuple_size<decltype(tupel)>::value, decltype(tupel)>(tupel);
}
