#ifndef C_H
#define C_H
#include "B.h"

class C : public B {
public:
  C(int a_, int b_, int c_)
      : B(a_, b_),                          // Oberklassen-Subobjekt
        c{c_}
  {                                         // ggf. lokale Daten
  }

  C(const C&) = delete;
  C& operator=(const C&) = delete;
  C(C&&) = delete;
  C& operator=(C&&) = delete;

  virtual std::unique_ptr<A> clone() const override
  {
    std::cout << "virtual C* C::clone()\n";
    return std::unique_ptr<A>(new C(A::get(), B::get(), c));
  }

  virtual void ausgabe() const override
  {
    B::ausgabe();
    std::cout << "C.c = " << c << ' ';
  }

protected:
  auto get() const { return c; }
  virtual bool isEqual(const A& arg) const override
  {
    std::cout << "C::isEqual(const A& arg)\n";
    return B::isEqual(arg) && c == static_cast<const C&>(arg).c;
  }

private:
  int c;
};
#endif
