#include <compare>
#include <iostream>
#include <typeinfo>

class Punkt {
public:
  constexpr Punkt(int x_ = 0, int y_ = 0) : x(x_), y(y_) {}
  constexpr int getx() const { return x;}
  constexpr int gety() const { return y;}
  constexpr auto operator<=>(const Punkt&) const = default;  // !
private:
  int x;
  int y;
};

int main()
{
  constexpr Punkt a {10, 10};
  constexpr Punkt b {10, 10};
  // Existenz der Operatoren nachweisen
  static_assert(a == b);
  static_assert(!(a != b));
  static_assert(!(a < b));
  static_assert(a <= b);
  static_assert(!(a > b));
  static_assert(a >= b);
  std::cout << typeid(a <=> b).name() << '\n';
}
